# BreakoutApp Class Reference

`#include <BreakoutApp.h>`

Inheritance diagram for BreakoutApp:

List of all members.

## Public Member Functions
| BreakoutApp ()
| ~BreakoutApp ()
void | Run ()
void | Draw ()
void | Update ()
void | Initialise ()
void | Shutdown ()
virtual bool | HandleEvent (IEvent *pEvent)
SDL_Surface * | GetScreen ()
SpriteID | GetBoxSpriteFromHealth (unsigned int health)
## Static Public Member Functions
static BreakoutApp * | getSingleton ()
static void | deleteSingleton ()
## Protected Types
enum | eSceneType { eGameScene = 0, eMainMenuScene, ePauseScene, eGameOverScene, eSplashScreenScene, eErrorScene, eNumSceneTypes }
## Protected Member Functions
void | InitialiseScenes ()
void | ChangeScene (const eSceneType &sceneType)
## Protected Attributes
bool | m_bQuitGame
int | m_bgMusicID
eSceneType | m_currentScene
IScene * | m_sceneArray [eNumSceneTypes]
std::vector< SpriteID > | m_vBoxSprites
SDL_Surface * | m_pScreen
## Static Protected Attributes
static BreakoutApp * | m_pInstance = NULL

## Detailed Description

Definition at line 13 of file BreakoutApp.h.

## Member Enumeration Documentation

enum BreakoutApp::eSceneType`[protected]`

Enumerator:

  eGameScene |
  eMainMenuScene |
  ePauseScene |
  eGameOverScene |
  eSplashScreenScene |
  eErrorScene |
  eNumSceneTypes |

Definition at line 39 of file BreakoutApp.h.

## Constructor & Destructor Documentation

BreakoutApp::BreakoutApp | ( |  | ) |

Definition at line 26 of file BreakoutApp.cpp.

BreakoutApp::~BreakoutApp | ( |  | ) |

Definition at line 33 of file BreakoutApp.cpp.

## Member Function Documentation

void BreakoutApp::ChangeScene | ( | const eSceneType & | sceneType | ) | `[protected]`

Definition at line 312 of file BreakoutApp.cpp.

static void TSingleton< BreakoutApp >::deleteSingleton | ( |  | ) | `[inline, static, inherited]`

Definition at line 22 of file TSingleton.h.

void BreakoutApp::Draw | ( |  | ) |

Definition at line 102 of file BreakoutApp.cpp.

SpriteID BreakoutApp::GetBoxSpriteFromHealth | ( | unsigned int | health | ) | `[inline]`

Definition at line 30 of file BreakoutApp.h.

SDL_Surface* BreakoutApp::GetScreen | ( |  | ) | `[inline]`

Definition at line 29 of file BreakoutApp.h.

static BreakoutApp * TSingleton< BreakoutApp >::getSingleton | ( |  | ) | `[inline, static, inherited]`

Definition at line 15 of file TSingleton.h.

bool BreakoutApp::HandleEvent | ( | IEvent * | pEvent | ) | `[virtual]`

Implements IEventListener.

Definition at line 249 of file BreakoutApp.cpp.

void BreakoutApp::Initialise | ( |  | ) |

Definition at line 123 of file BreakoutApp.cpp.

void BreakoutApp::InitialiseScenes | ( |  | ) | `[protected]`

Definition at line 191 of file BreakoutApp.cpp.

void BreakoutApp::Run | ( |  | ) |

Definition at line 37 of file BreakoutApp.cpp.

void BreakoutApp::Shutdown | ( |  | ) |

Definition at line 229 of file BreakoutApp.cpp.

void BreakoutApp::Update | ( |  | ) |

Definition at line 111 of file BreakoutApp.cpp.

## Member Data Documentation

int BreakoutApp::m_bgMusicID`[protected]`

Definition at line 55 of file BreakoutApp.h.

bool BreakoutApp::m_bQuitGame`[protected]`

Definition at line 53 of file BreakoutApp.h.

eSceneType BreakoutApp::m_currentScene`[protected]`

Definition at line 56 of file BreakoutApp.h.

BreakoutApp * TSingleton< BreakoutApp >::m_pInstance = NULL`[inline, static, protected, inherited]`

Definition at line 29 of file TSingleton.h.

SDL_Surface* BreakoutApp::m_pScreen`[protected]`

Definition at line 61 of file BreakoutApp.h.

IScene* BreakoutApp::m_sceneArray[eNumSceneTypes]`[protected]`

Definition at line 57 of file BreakoutApp.h.

std::vector<SpriteID> BreakoutApp::m_vBoxSprites`[protected]`

Definition at line 58 of file BreakoutApp.h.

The documentation for this class was generated from the following files:

- C:/Users/Public/AGS Final Folder/BFLETCHER D4010283/Source/Game/Source/BreakoutApp.h
- C:/Users/Public/AGS Final Folder/BFLETCHER D4010283/Source/Game/Source/BreakoutApp.cpp